﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Silverlight.Chart;
using System.Xml.Linq;


namespace AreaChart
{
    public partial class MainPage : UserControl
    {        
        private XamWebChart _XamAreaChartChart1;
        string strXDoc = string.Empty;
        public MainPage()
        {
           
                InitializeComponent();
            
        }
        private void tpAreaChart1_Loaded(object sender, RoutedEventArgs e)
        {
            
                _XamAreaChartChart1 = (XamWebChart)sender;
                strXDoc =
            "<ControlData DashboardId=\"2\" ControlID=\"5\" ControlName=\"tpAreaChart1\">   " +
              "<ItemData>     " +
                "<GroupField DeptID=\"1\">       " +
                "    <Data Stay=\"19\" DeptID=\"1\" DeptName=\"Cardiology\" />       " +
                 "   <Data Stay=\"9\" DeptID=\"1\" DeptName=\"Nephrology\" />      " +
                 "</GroupField>     " +
                "<GroupField DeptID=\"2\">       " +
                 "   <Data Stay=\"9\" DeptID=\"2\" DeptName=\"Cardiology\" />        " +
               "     <Data Stay=\"9\" DeptID=\"2\" DeptName=\"Neonatal\" />       " +
            "        <Data Stay=\"9\" DeptID=\"2\" DeptName=\"Nephrology\" />   " +
               " </GroupField>     " +
                "<GroupField DeptID=\"3\">       " +
                 "   <Data Stay=\"9\" DeptID=\"3\" DeptName=\"Neonatal\" />     " +
              "  </GroupField>   " +
               "</ItemData> " +
              "</ControlData>";
                LoadAreaChartData(_XamAreaChartChart1);
          

        }
        private void LoadAreaChartData(XamWebChart _XamAreaChartChart)
        {
            XDocument doc;
            string xCol;
            string yCol;
            xCol = "DeptName";
            yCol = "Stay";
            doc = XDocument.Parse(strXDoc);

            List<ControlSeries> ListControlSeries = new List<ControlSeries>();
            string groupByAttribute = string.Empty;
            groupByAttribute = "DeptID";
            if (groupByAttribute != string.Empty)
                ListControlSeries =
                    (from d in doc.Descendants("GroupField")
                     where d.Parent.Parent.Attribute("ControlName").Value == Convert.ToString("tpAreaChart1").Trim()
                     select new ControlSeries
                     {
                         Value = d.Attribute(groupByAttribute).Value,
                         ControlName = d.Parent.Parent.Attribute("ControlName").Value
                     }).ToList<ControlSeries>();

            int i = 0;
            _XamAreaChartChart.Series.Clear();
            foreach (ControlSeries Series in ListControlSeries)
            {
                #region Dynamic Series
                //Setting xCol and yCol and Serice
                Infragistics.Silverlight.Chart.Series MySeries = new Infragistics.Silverlight.Chart.Series();

                //MySeries.DataMapping = "Value=" + Control.xCol + ";Label=" + Control.yCol;
                MySeries.DataMapping = "Value=Value" + ";Label=Name";//"Value=Value"    ";Label=Name"
                MySeries.ChartType = Infragistics.Silverlight.Chart.ChartType.Column;

                //Default Animation
                Infragistics.Silverlight.Chart.Animation a = new Infragistics.Silverlight.Chart.Animation();
                MySeries.Animation = a;

                _XamAreaChartChart.Series.Add(MySeries);
                #endregion

                var dataSource =
                   (from d in doc.Descendants("GroupField").Descendants("Data")
                    where d.Parent.Parent.Parent.Attribute("ControlName").Value == Convert.ToString(_XamAreaChartChart.Tag).Trim() &&
                    d.Parent.Attribute(groupByAttribute).Value == Series.Value
                    select new ChartDataMapper
                    {

                        Value = (double)d.Attribute(yCol),
                        Name = (string)d.Attribute(xCol).Value
                    }).ToList<ChartDataMapper>();
                if (dataSource.Where(p => p.Name == "Cardiology").Count() == 0)
                    dataSource.Add(new ChartDataMapper() { Value = 0, Name = "Cardiology" });
                if (dataSource.Where(p => p.Name == "Neonatal").Count() == 0)
                    dataSource.Add(new ChartDataMapper() { Value = 0, Name = "Neonatal" });
                if (dataSource.Where(p => p.Name == "Nephrology").Count() == 0)
                    dataSource.Add(new ChartDataMapper() { Value = 0, Name = "Nephrology" });
                dataSource.Sort();
                _XamAreaChartChart.Series[i].DataSource = dataSource;
                _XamAreaChartChart.Series[i].Label = Series.Value;
                i++;


            }
        }
    
    }

    public class ChartDataMapper:IComparable
    {
        /// <summary>
        /// Name is xCol
        /// Name/xCol always double
        /// </summary>
        public string Name { get; set; }
        public double Value { get; set; }

        public int CompareTo(object obj)
        {
            
            return this.Name.CompareTo((obj as ChartDataMapper).Name);

        }
    }
    public class ControlSeries 
    {
        public string Value
        { get; set; }

        public string ControlName
        { get; set; }
    }

      
}
